Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/vsposp_typical.sh
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/vsposp_typical.sh	(revision 1658)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/vsposp_typical.sh	(revision 1660)
@@ -13,7 +13,8 @@
 #SCENE=vsposp_typical
 #SCENE=soda5_vsposp
-#SCENE=soda_vsposp
+SCENE=soda_vsposp
 #SCENE=vienna_vsposp
-SCENE=vsposp_citymodel
+#SCENE=arena_vsposp
+#SCENE=vsposp_citymodel
 #SCENE=soda5
 #SCENE=cube
@@ -63,12 +64,13 @@
  echo "$SCENE $METHOD"
 
-# $PROGRAM $ENVIRONMENT \
-# -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
-# -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
-# -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
-# -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
-# -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
-# -hierarchy_construction_type=2 \
-# -hierarchy_construction_recompute_split_on_repair=true
+  $PROGRAM $ENVIRONMENT \
+  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+  -hierarchy_construction_type=2 \
+  -hierarchy_construction_multilevel=false \
+  -hierarchy_construction_recompute_split_on_repair=true
 
 sh movefiles.sh $LOG_PREFIX-$METHOD
@@ -77,41 +79,4 @@
 ############################################################################
 NODES=1000
-
-  METHOD=sequential-$NODES
-  echo "$SCENE $METHOD"
-
-# $PROGRAM $ENVIRONMENT \
-#  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
-#  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
-#  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
-#  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
-#  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
-#  -hierarchy_construction_type=0 \
-#  -bvh_term_max_leaves=$NODES
-
-sh movefiles.sh $LOG_PREFIX-$METHOD
-
-############################################################################
-
-NODES=10000
-
-  METHOD=sequential-$NODES
-  echo "$SCENE $METHOD"
-
-# $PROGRAM $ENVIRONMENT \
-#  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
-#  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
-#  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
- # -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
- # -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
- # -hierarchy_construction_type=0 \
-#  -bvh_term_max_leaves=$NODES
-
-sh movefiles.sh $LOG_PREFIX-$METHOD
-
-
-############################################################################
-
-NODES=30000
 
   METHOD=sequential-$NODES
@@ -126,4 +91,41 @@
   -hierarchy_construction_type=0 \
   -bvh_term_max_leaves=$NODES
+
+sh movefiles.sh $LOG_PREFIX-$METHOD
+
+############################################################################
+
+NODES=10000
+
+  METHOD=sequential-$NODES
+  echo "$SCENE $METHOD"
+
+ $PROGRAM $ENVIRONMENT \
+  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+  -hierarchy_construction_type=0 \
+  -bvh_term_max_leaves=$NODES
+
+sh movefiles.sh $LOG_PREFIX-$METHOD
+
+
+############################################################################
+
+NODES=30000
+
+  METHOD=sequential-$NODES
+  echo "$SCENE $METHOD"
+
+#  $PROGRAM $ENVIRONMENT \
+#   -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+#   -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+#   -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+#   -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+#   -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+#   -hierarchy_construction_type=0 \
+#   -bvh_term_max_leaves=$NODES
 
 sh movefiles.sh $LOG_PREFIX-$METHOD
@@ -147,2 +149,20 @@
 
 sh movefiles.sh $LOG_PREFIX-$METHOD
+
+###############################################################
+
+# METHOD=gradient-multi
+# echo "$SCENE $METHOD"
+
+# $PROGRAM $ENVIRONMENT \
+# -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+# -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+# -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+ #-bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+# -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+# -hierarchy_construction_type=2 \
+# -hierarchy_construction_multilevel=true \
+# -hierarchy_construction_levels=4 \
+# -hierarchy_construction_recompute_split_on_repair=true
+
+sh movefiles.sh $LOG_PREFIX-$METHOD