Index: GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 1663)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 1665)
@@ -2171,5 +2171,5 @@
 				optFloat,
 				"vsp_construction_render_cost_decrease_weight=",
-				"1.0");
+				"0.99");
 
 	RegisterOption("VspTree.Termination.maxDepth",
@@ -2459,5 +2459,5 @@
 				   optFloat,
 				   "bvh_construction_render_cost_decrease_weight=",
-				   "1.0");
+				   "0.99");
 	
 	RegisterOption("BvHierarchy.Construction.useGlobalSorting",
Index: GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 1664)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 1665)
@@ -543,4 +543,6 @@
 		const float factor = mRenderCostDecreaseWeight;
 		
+		priority = factor * renderCostDecr + (1.0f - factor) * oldRenderCost;
+
 		// take render cost of node into account 
 		// otherwise danger of being stuck in a local minimum!!
@@ -549,9 +551,5 @@
 			//cout << "here7 rc: " << factor * renderCostDecr << " pvs: " << (1.0f - factor) * splitCandidate.GetPvsEntriesIncr() << endl;
 			//priority = factor * renderCostDecr - (1.0f - factor) * splitCandidate.GetPvsEntriesIncr();// / mBvhStats.Leaves();
-			priority = renderCostDecr / ((float)splitCandidate.GetPvsEntriesIncr() + 1.0f);
-		}
-		else
-		{
-			priority = factor * renderCostDecr + (1.0f - factor) * oldRenderCost;
+			priority /= ((float)splitCandidate.GetPvsEntriesIncr() + 1.0f);
 		}
 	}
@@ -584,5 +582,5 @@
 	const float factor = mRenderCostDecreaseWeight;
 	
-	float priority;
+	float priority = factor * renderCostDecr + (1.0f - factor) * oldRenderCost;
 
 	// $$ matt temp
@@ -591,11 +589,7 @@
 		//cout << "here5 rc: " << factor * renderCostDecr << " pvs: " << (1.0f - factor) * splitCandidate.GetPvsEntriesIncr() << endl;
 		//const float priority = factor * renderCostDecr - (1.0f - factor) * (float)splitCandidate.GetPvsEntriesIncr();
-		priority = renderCostDecr / ((float)splitCandidate.GetPvsEntriesIncr() + 1.0f);
-	}
-	else
-	{
-		priority = factor * renderCostDecr + (1.0f - factor) * oldRenderCost;
-	}
-
+		priority /= ((float)splitCandidate.GetPvsEntriesIncr() + 1.0f);
+	}
+	
 	return priority;
 }
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 1664)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 1665)
@@ -822,5 +822,5 @@
 	const float factor = mRenderCostDecreaseWeight;
 
-	float priority;
+	float priority = factor * renderCostDecr + (1.0f - factor) * oldRenderCost;
 
 	if (mHierarchyManager->mConsiderMemory)
@@ -828,9 +828,5 @@
 		//cout << "here4 rc: " << factor * renderCostDecr << " pvs: " << (1.0f - factor) * splitCandidate.GetPvsEntriesIncr() << endl;
 		//const float priority = factor * renderCostDecr - (1.0f - factor) * splitCandidate.GetPvsEntriesIncr();
-		priority = renderCostDecr / ((float)splitCandidate.GetPvsEntriesIncr() +  + 1.0f);
-	}
-	else
-	{
-		priority = factor * renderCostDecr + (1.0f - factor) * oldRenderCost;
+		priority /= ((float)splitCandidate.GetPvsEntriesIncr() +  + 1.0f);
 	}
 	
@@ -851,5 +847,5 @@
 	const float factor = mRenderCostDecreaseWeight;
 
-	float priority;
+	float priority = factor * renderCostDecr + (1.0f - factor) * oldRenderCost;
 
 	if (mHierarchyManager->mConsiderMemory)
@@ -857,9 +853,5 @@
 		//cout << "here2 rc: " << factor * renderCostDecr << " pvs: " << (1.0f - factor) * splitCandidate.GetPvsEntriesIncr() << endl; 
 		//const float priority = factor * renderCostDecr - (1.0f - factor) * splitCandidate.GetPvsEntriesIncr();
-		priority = renderCostDecr / ((float)splitCandidate.GetPvsEntriesIncr() + 1.0f);
-	}
-	else
-	{
-		priority = factor * renderCostDecr + (1.0f - factor) * oldRenderCost;
+		priority /= ((float)splitCandidate.GetPvsEntriesIncr() + 1.0f);
 	}
 